package ru.amse.kanzheleva.moviemaker.movie.figures;

import ru.amse.kanzheleva.moviemaker.movie.ColorRGB;
import ru.amse.kanzheleva.moviemaker.movie.IVisitor;
import ru.amse.kanzheleva.moviemaker.movie.MyPoint;

public class Rectangle extends RectangularFigure implements IRectangle {
	
	public Rectangle() {
		
	}
	
	public Rectangle(ColorRGB lineColor, ColorRGB fillColor,
			int xPosition, int yPosition, 
			int width, int height,
			double rotationAhgle, 
			int xRotationCenter, int yRotationCenter) {
		
		ColorRGB newLineColor = new ColorRGB(lineColor.getRed(), lineColor.getGreen(), 
				lineColor.getBlue());
		setLineColor(newLineColor);
		ColorRGB newFillColor = new ColorRGB(fillColor.getRed(), fillColor.getGreen(), 
				fillColor.getBlue());
		setFillColor(newFillColor);
		
		MyPoint rectanglePoint = new MyPoint(xPosition, yPosition);
		setPosition(rectanglePoint);
		
		setWidth(width);
		setHeight(height);
		
		MyPoint rotationPoint = new MyPoint(xRotationCenter, yRotationCenter);
		setRotationAngle(rotationAhgle);
		setRotationCenter(rotationPoint);
	}
	
	public <R, P> R visit(IVisitor<R, P> dr, P attributes) {
		return dr.visit(this, attributes);
	}
}
