package ru.amse.kanzheleva.moviemaker.ui.frame;

import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JToolBar;

public class AddPanel extends JToolBar{
	private JButton myEllipseButton;
	private JButton myRectangleButton;
	private JButton myRountRectangleButton;
	private JButton myPolyLineButton;
	private JButton myPolygonButton;
	
	private JButton myDeleteButton;
	
	private JButton myFillColorButton;
	private JButton myLineColorButton;
	
	private static final long serialVersionUID = 1L;

	public AddPanel() {
		super();
		addButtons();
	}
	
	private final void addButtons() {
		myEllipseButton = new JButton("Ellipse");
		myRectangleButton = new JButton("Rectangle");
		myRountRectangleButton = new JButton("Rountrectangle");
		myPolyLineButton = new JButton("Polyline");
		myPolygonButton = new JButton("Polygon");
		myFillColorButton = new JButton("Fill Color");
		myLineColorButton = new JButton("Line Color");
		myDeleteButton = new JButton("Delete");
		
		
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		add(myEllipseButton);
		add(myRectangleButton);
		add(myRountRectangleButton);
		add(myPolyLineButton);
		add(myPolygonButton);
		add(myFillColorButton);
		add(myLineColorButton);
		add(myDeleteButton);
	}
	
	public void setEnable(boolean able) {
		myFillColorButton.setEnabled(able);
		myLineColorButton.setEnabled(able);
		myDeleteButton.setEnabled(able);
	}
	
	public void addEllipseListener(ActionListener actionListener) {
		myEllipseButton.addActionListener(actionListener);
	}
	
	public void addRectangleListener(ActionListener actionListener) {
		myRectangleButton.addActionListener(actionListener);
	}
	
	public void addRoundRectangleListener(ActionListener actionListener) {
		myRountRectangleButton.addActionListener(actionListener);
	}

	public void addPolyLineListener(ActionListener actionListener) {
		myPolyLineButton.addActionListener(actionListener);
	}
	
	public void addPolygonListener(ActionListener actionListener) {
		myPolygonButton.addActionListener(actionListener);
	}
	
	public void addFillColorListener(ActionListener actionListener) {
		myFillColorButton.addActionListener(actionListener);
	}
	
	public void addLineColorListener(ActionListener actionListener) {
		myLineColorButton.addActionListener(actionListener);
	}
	
	public void addDeleteListener(ActionListener actionListener) {
		myDeleteButton.addActionListener(actionListener);
	}
}
