package ru.amse.kanzheleva.moviemaker.ui.frame.actions;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.xml.stream.XMLStreamException;

import ru.amse.kanzheleva.moviemaker.ui.frame.FrameMaker;
import ru.amse.kanzheleva.moviemaker.xml.WrongDataException;

public class EditSaveAction extends AbstractAction {
	private static final long serialVersionUID = 1L;
	private FrameMaker myParent;
	
	public EditSaveAction(FrameMaker parent) {
		super();
		myParent = parent;
	}
	
	public void actionPerformed(ActionEvent arg0) {
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setFileFilter(new FileFilter() {
			@Override
			public boolean accept(File f) {
				if (f.isDirectory() || f.getName().toLowerCase().endsWith(".xml")) {
					return true;
				} 
				return false;
			}

			@Override
			public String getDescription() {
				return ".xml files";
			}
			
		});
		fileChooser.showSaveDialog(null);
		File saveFile = fileChooser.getSelectedFile();
		if (saveFile != null) {
			if (!saveFile.getName().toLowerCase().endsWith(".xml")) {
				saveFile = new File(saveFile.getAbsolutePath() + ".xml");
				System.out.println("hello");
			}
			try {
				myParent.saveMovie(saveFile);
			} catch (WrongDataException e) {
				throw e;
			} catch (XMLStreamException e) {
				throw new WrongDataException(e.toString());
			}
		}
		
	}

}
