package ru.amse.kanzheleva.moviemaker.ui.frameeditor;

import ru.amse.kanzheleva.moviemaker.movie.ColorRGB;
import ru.amse.kanzheleva.moviemaker.movie.IVisitor;
import ru.amse.kanzheleva.moviemaker.movie.Moviable;
import ru.amse.kanzheleva.moviemaker.movie.MyPoint;
import ru.amse.kanzheleva.moviemaker.movie.figures.IEllipse;
import ru.amse.kanzheleva.moviemaker.movie.figures.IPolyFigure;
import ru.amse.kanzheleva.moviemaker.movie.figures.IPolyLine;
import ru.amse.kanzheleva.moviemaker.movie.figures.IPolygon;
import ru.amse.kanzheleva.moviemaker.movie.figures.IRectangle;
import ru.amse.kanzheleva.moviemaker.movie.figures.IRectangularFigure;
import ru.amse.kanzheleva.moviemaker.movie.figures.IRoundRectangle;

public class FigureFieldsFiller implements IVisitor<Void, Integer>{

	public Void visit(IRectangle rectangle, Integer attributes) {
		fillRectangleFigure(rectangle);
		return null;
	}

	public Void visit(IRoundRectangle rectangle, Integer attributes) {
		fillRectangleFigure(rectangle);
		rectangle.setCurveHeight(40);
		rectangle.setCurveWidth(40);
		return null;
	}

	public Void visit(IEllipse ellipse, Integer attributes) {
		fillRectangleFigure(ellipse);
		return null;
	}

	public Void visit(IPolygon polygon, Integer attributes) {
		fillPolylineFigure(polygon, attributes);
		return null;
	}

	public Void visit(IPolyLine polyLine, Integer attributes) {
		fillPolylineFigure(polyLine, attributes);
		return null;
	}

	public Void visit(Moviable element, Integer attributes) {
		return null;
	}
	
	private void fillPolylineFigure(IPolyFigure figure, int n) {
		int[] x = new int[n];
		int[] y = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = (int) (40 * Math.cos(2 * Math.PI / n * i)) + 40;
			y[i] = (int) (40 * Math.sin(2 * Math.PI / n * i)) + 40;
		}
		figure.setFillColor(new ColorRGB(255, 0, 0));
		figure.setLineColor(new ColorRGB(0, 255, 0));
		figure.setRotationAngle(0);
		figure.setRotationCenter(new MyPoint(0, 0));
		figure.setX(x);
		figure.setY(y);
	}
	
	private void fillRectangleFigure(IRectangularFigure figure) {
		figure.setFillColor(new ColorRGB(255, 0, 0));
		figure.setLineColor(new ColorRGB(0 ,255, 0));
		figure.setHeight(100);
		figure.setWidth(100);
		figure.setPosition(new MyPoint(0, 0));
		figure.setRotationAngle(0);
		figure.setRotationCenter(new MyPoint(0, 0));
	}
}
