package ru.amse.kanzheleva.moviemaker.ui.previewpane;

import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import ru.amse.kanzheleva.moviemaker.movie.IFrame;
import ru.amse.kanzheleva.moviemaker.movie.IMovie;

public class PreviewPane extends JScrollPane {
	private static final long serialVersionUID = 1L;
	private JPanel myPanel = new JPanel();
	private Thumbnail myChosen;
	private IChooseListener myChoseListener;
	
	private int myWidth;
	private int myHeight;
	private double myScale;
	

	public PreviewPane(IMovie movie, double scale, int width, int height) {
		super();
		setViewportView(myPanel);
		myPanel.setLayout(new GridLayout());
		myPanel.setPreferredSize(new Dimension((int)(movie.getSize() * (width * scale + 10)), 
				(int)(height * scale)));
		myWidth = width;
		myHeight = height;
		myScale = scale;
		
		for (int i = 0; i < movie.getSize(); i++) {
			Thumbnail thumbnail = new Thumbnail(this, movie.getFrame(i), width, height,scale, scale, i);
			if (i == 0) {
				myChosen = thumbnail;
			}
			myPanel.add(thumbnail);
		}
		setPreferredSize(new Dimension(width, (int)(height * scale + 20)));
	}	
	
	public void redraw() {
		myChosen.repaint();
	}
	
	public boolean isThisChoosen(Thumbnail thumbnail) {
		return (myChosen == thumbnail);
	}
	
	public void Choose(Thumbnail thumbnail) {
		myChosen.repaint();
		thumbnail.repaint();
		myChosen = thumbnail;
		myChoseListener.frameChosen(thumbnail.getFrameNumber());
	}
	
	public void addListener(IChooseListener listener) {
		myChoseListener = listener;
	}
	
	public void addNewFrame(IFrame frame) {
		Thumbnail thumbnail = new Thumbnail(this, frame, myWidth, myHeight, 
				myScale, myScale, myPanel.getComponentCount());
		setViewportView(myPanel);
		myPanel.setPreferredSize(new Dimension((int)((myPanel.getComponentCount() + 1) *
				(myWidth * 0.2 + 10)), (int) (myHeight * 0.2)));
		myPanel.setLayout(new GridLayout());
		myPanel.add(thumbnail);
		Choose(thumbnail);		
		myPanel.repaint();
	}
	
	public void setNewMovie(IMovie movie) {
		setViewportView(myPanel);
		int counter = myPanel.getComponentCount();
		while(counter > 0) {
			counter--;
			myPanel.remove(counter);
		}
		
		myPanel.setPreferredSize(new Dimension((int)(movie.getSize() * (myWidth * myScale + 10)), 
				(int)(myHeight * myScale)));		
		myPanel.setLayout(new GridLayout());
		for (int i = 0; i < movie.getSize(); i++) {
			Thumbnail thumbnail = new Thumbnail(this, movie.getFrame(i), myWidth, myHeight, myScale, myScale, i);
			if (i == 0) {
				myChosen = thumbnail;
			}
			myPanel.add(thumbnail);
		}
	}
	
}
